
DEFINE CLASS _SerializableObject2XML AS CUSTOM
   Name="_SerializableObject2XML"
   PROTECTED iLevel,cBadChars,iObjectList
   PROTECTED ARRAY aObjectList(1)

   iLevel=-1
   iObjectList=0
   iFile=-1

   cBadChars=""
   PROCEDURE Init
      LOCAL lcBadChars
      lcBadChars=""
      FOR lii=0 TO 8
          lcBadChars=lcBadChars+CHR(lii)
      NEXT
      FOR lii=10 TO 31
          lcBadChars=lcBadChars+CHR(lii)
      NEXT
      This.cBadChars=lcBadChars
   ENDPROC

   PROCEDURE StrTranHTMLString(lcString)
      * lcString 
      RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.lcString,"&","&amp;"),">","&gt;"),"<","&lt;"),'"',"&quot;")
   ENDPROC

   PROTECTED PROCEDURE AddObject2List(loObj)
      LOCAL llExist
      llExist=PEMSTATUS(loObj,"__SerializableObjectID",5)
      IF NOT llExist
         This.iObjectList=This.iObjectList+1
         DIME This.aObjectList(This.iObjectList)
         This.aObjectList(This.iObjectList)=loObj
         =ADDPROPERTY(loObj,"__SerializableObjectID",SYS(2015))
      ENDIF
      RETURN llExist
   ENDPROC

   PROTECTED PROCEDURE FreeObjectList()
      LOCAL lii
      FOR lii=1 TO This.iObjectList
         =REMOVEPROPERTY(This.aObjectList(lii),"__SerializableObjectID")
      NEXT
      STORE .NULL. TO This.aObjectList
      This.iObjectList=0
      DIME This.aObjectList(1)
   ENDPROC

   PROCEDURE Serializable(luValue,lcFile) && Convert object to XML
      * luValue - Object reference
      * lcFile  - Output file name
      IF EMPTY(lcFile)
         lcFile=SYS(2023)+"\"+SYS(2015)+".xml"
      ENDIF   
      This.iFile=FCREATE(lcFile,0)
      IF This.iFile<=0
         RETURN ""
      ENDIF

      TEXT TO lcData TEXTMERGE NOSHOW
<?xml version="1.0" encoding="windows-<<CPCURRENT()>>" standalone="yes"?>
<result>

      ENDTEXT
      =FWRITE(This.iFile,lcData)

      This.ToXML(luValue) && Convert object to XML

      TEXT TO lcData TEXTMERGE NOSHOW 
</result>

      ENDTEXT
      =FWRITE(This.iFile,lcData)
      =FCLOSE(This.iFile)
      This.iFile=-1
      This.FreeObjectList()
      RETURN lcFile
   ENDPROC


   PROTECTED PROCEDURE ToXML(luValue) && Convert object to XML
      * luValue - Object reference
      LOCAL lcType,lii,liy,liz,loObj,lcPom,liRows,liCols,lcpom2,lcName,lcTABs,;
            lcValue,lcPEM,luMember,lix,llExist,luItem,llObj
      LOCAL ARRAY laMembers(1)  

      This.iLevel=This.iLevel+1
      lcTABs=SPACE(This.iLevel)

      lcType=VARTYPE(luValue)  && Typ ofpassed value
      IF lcType#'O' OR ISNULL(luValue)
         TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>"><<IIF(lcTYPE$"CM",IIF(LEN(CHRTRAN(luValue,This.cBadChars,""))=LEN(luValue), This.StrTranHTMLString(luValue),STRCONV(luValue,13)),luValue)>></value>

         ENDTEXT
         =FWRITE(This.iFile,lcData)
         This.iLevel=This.iLevel-1
         RETURN ""
      ENDIF

      
      IF PEMSTATUS(luValue,"BaseClass",5) AND UPPER(luValue.BaseClass)=='COLLECTION'
         TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><collection>

         ENDTEXT
         =FWRITE(This.iFile,lcData)
         FOR liz=1 TO luValue.Count
             luItem=luValue.Item(liz)

             llObj=VARTYPE(luItem)="O"   
             llExist=IIF(llObj,This.AddObject2List(luItem),.F.)

             IF llObj
                IF TYPE("luItem.Name")="C"
                   TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><object name="<<luItem.Name>>">

                   ENDTEXT
                ELSE
                   TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><object name="">

                   ENDTEXT
                ENDIF   
                =FWRITE(This.iFile,lcData)
             ENDIF   
             IF NOT llExist
                This.ToXML(luItem)
             ELSE
                TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luItem.__SerializableObjectID>>" />

                ENDTEXT
                =FWRITE(This.iFile,lcData)
             ENDIF
             IF llObj
                TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></object>

                ENDTEXT
                =FWRITE(This.iFile,lcData)
             ENDIF   
         NEXT
         TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></collection>

         ENDTEXT
         =FWRITE(This.iFile,lcData)
      ENDIF 

      * walk member list
      lcValue='' 
      liy=AMEMBERS(laMembers,luValue) 
      FOR lii=1 TO liy
          lcPEM=laMembers(lii)

          TRY
            lcType=IIF(TYPE("ALEN(luValue."+lcPEM+")")="N","A",TYPE('EVAL("luValue."+lcPEM)'))
          CATCH 
            lcType="U"
          ENDTRY  

          DO CASE
             CASE lcPEM=='OBJECTS'
                  TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><collection name="<<lcPEM>>" />

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

             CASE lcPEM=='CONTROLS'
                  TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><collection name="<<lcPEM>>" />

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)
                  FOR liz=1 TO luValue.ControlCount
                      llExist=This.AddObject2List(luValue.Controls(liz))

                      IF TYPE("luValue.Controls(liz).Name")="C"
                         TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><object name="<<luValue.Controls(liz).Name>>">

                         ENDTEXT
                      ELSE
                         TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><object name="">

                         ENDTEXT
                      ENDIF   
                      =FWRITE(This.iFile,lcData)
                      IF NOT llExist
                         This.ToXML(luValue.Controls(liz))
                      ELSE
                         TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Controls(liz).__SerializableObjectID>>" />

                         ENDTEXT
                         =FWRITE(This.iFile,lcData)
                      ENDIF
                      TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></object>

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                  NEXT

             CASE lcPEM=='PAGES'
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><collection name="<<lcPEM>>" />

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)
                  FOR liz=1 TO luValue.PageCount
                      llExist=This.AddObject2List(luValue.Pages(liz))

                      TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<luValue.Pages(liz).Name>>">

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                      IF NOT llExist
                         This.ToXML(luValue.Pages(liz))
                      ELSE
                         TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Pages(liz).__SerializableObjectID>>" />

                         ENDTEXT
                         =FWRITE(This.iFile,lcData)
                      ENDIF
                      TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>></object>

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                  NEXT

             CASE lcPEM=='COLUMNS'
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><collection name="<<lcPEM>>" />
                  ENDTEXT
                  =FWRITE(This.iFile,lcData)
                  FOR liz=1 TO luValue.ColumnCount
                      llExist=This.AddObject2List(luValue.Columns(liz))

                      TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<luValue.Columns(liz).Name>>">
                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                      IF NOT llExist
                         This.ToXML(luValue.Columns(liz))
                      ELSE
                         TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<luValue.Columns(liz).__SerializableObjectID>>" />

                         ENDTEXT
                         =FWRITE(This.iFile,lcData)
                      ENDIF
                         
                      TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>></object>

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                  NEXT


             CASE lcPEM=='ACTIVEFORM' OR lcPEM=='ACTIVECONTROL' OR lcPEM=='PARENT'
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<lcPEM>>"><<IIF(TYPE('luValue.'+lcPEM)<>'O','',EVAL('luValue.'+lcPEM+'.Name'))>></object>

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

             CASE lcType="A"
                  lcPom='luValue.'+lcPEM
                  liRows=EVAL("ALEN("+lcPom+",1)")
                  liCols=EVAL("ALEN("+lcPom+",2)")
                  IF liCols>0
                     TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><array name="<<lcPEM>>" rows="<<liRows>>" cols="<<liCols>>">

                     ENDTEXT
                  ELSE
                     TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><array name="<<lcPEM>>" rows="<<liRows>>">

                     ENDTEXT
                  ENDIF
                  =FWRITE(This.iFile,lcData)

                  * walk cells
                  FOR liz=1 TO EVAL("ALEN("+lcPom+")")
                      IF liCols>0
                         liRow=INT((liz-1)/liCols)+1
                         liCol=liz-((liRow-1)*liCols)
                         
                         TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><cell row="<<liRow>>" col="<<liCol>>">

                         ENDTEXT
                      ELSE
                         TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><cell row="<<liz>>">

                         ENDTEXT
                      ENDIF   
                      =FWRITE(This.iFile,lcData)
                      This.ToXML(EVAL(lcPom+"(liz)"))
                      TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></cell>

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                  NEXT
                                    
                  TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></array>

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

             CASE lcPEM=='LIST'
                  lcPom='luValue.'+lcPEM
                  liRows=luValue.ListCount
                  liCols=luValue.ColumnCount
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><list rows="<<liRows>>" cols="<<liCols>>">

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

                  FOR liRow=1 TO liRows
                      TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><listrow row="<<liRow>>">

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                      FOR liCol=1 TO liCols
                          TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><listcol col="<<liCol>>">

                          ENDTEXT
                          =FWRITE(This.iFile,lcData)

                          This.ToXML(luValue.List(liRow,liCol))
                          TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></listcol>

                          ENDTEXT
                          =FWRITE(This.iFile,lcData)
                      NEXT   

                      TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></listrow>

                      ENDTEXT
                      =FWRITE(This.iFile,lcData)
                  NEXT
                                    
                  TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>></list>

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)
   

             CASE lcType='O'
                  loObj=EVAL("luValue."+lcPEM)
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><object name="<<lcPEM>>">

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

                  IF !ISNULL(loObj)  && pokud ona vlastnost je nenulov
                     llExist=This.AddObject2List(loObj)
                     IF NOT llExist
                        * pak pidej nzae nalinkovanho objektu
                        This.ToXML(loObj)
                     ELSE
                        TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><linkedobject name="<<loObj.__SerializableObjectID>>" />

                        ENDTEXT
                        =FWRITE(This.iFile,lcData)
                     ENDIF
                  ENDIF   
                  TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>></object>

                  ENDTEXT
                  =FWRITE(This.iFile,lcData)

             OTHERWISE

                  DO CASE
                     CASE lcType==""
                          lcPom= This.StrTranHTMLString("Damaged property")
                          TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<lcPom>></value>

                          ENDTEXT
                          =FWRITE(This.iFile,lcData)
                          
                     CASE lcType="U"
                          lcPom= This.StrTranHTMLString("Hidden or Protected property")
                          TEXT TO lcData TEXTMERGE NOSHOW
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<lcPom>></value>

                          ENDTEXT
                          =FWRITE(This.iFile,lcData)
                     
                     OTHERWISE
                          luMember=EVAL("luValue."+lcPEM)

                          TEXT TO lcData TEXTMERGE NOSHOW 
<<lcTABs>><value type="<<lcType>>" name="<<lcPEM>>"><<IIF(lcType$"CM",IIF(LEN(CHRTRAN(luMember,This.cBadChars,""))=LEN(luMember), This.StrTranHTMLString(luMember),STRCONV(luMember,13)),luMember)>></value>

                          ENDTEXT
                          =FWRITE(This.iFile,lcData)
                  ENDCASE
          ENDCASE

      NEXT
      This.iLevel=This.iLevel-1
      RETURN ""
   ENDPROC

ENDDEFINE
